#ifndef _INTER_H
#define _INTER_H

#include "modeldef.h"

/* include file for interpreter */

int Exec(PC startpc);
extern jmp_buf rterrorret;
extern int jumpval;
extern byte ex;
/* touch */
extern bool touched, newtouched;
#ifdef __HITACHI__
extern bool rtch;
#endif

void WaitNoTouch(void);



/* constants for interpreter code and interpreter functions */
#include "bcodes.h"
#include "ifunc.h"

/* check for touch during runtime */
bool check_touch(void);

/* definitions for data access */

#define fstore(ad,fval) *(FLOATT FAR*) &(xdata[ad]) = (fval)
#define fdata(ad)       (*(FLOATT FAR*) &(xdata[ad]))

#define istore(ad,fval) xdata[ad]=(fval)
#define idata(ad)       xdata[ad]

/*#define bstore(ad,fval) xdata[ad]=(fval)
#define bdata(ad)       xdata[ad]*/

#ifdef LSI_C
extern int bk_counter;
#endif

#define ESC_X1 140
#define ESC_Y1 160
#define ESC_Y2 180

bool verify_abort (void);
bool jump (int addr, int statval);
int getleverpush ();

#define ARRAY(typ) \
  int index=ipop_fast(); \
  int addr=TOS; \
  if ((index<0)||(index>=xdata[addr-1])) \
    { \
      rterror(FN_ARRAY,30); \
      return; \
    } \
  TOS=addr+index*(sizeof(typ)/sizeof(int));

#define ARRAY2(typ) \
  int addr=ST2; \
  int index2=ipop_fast(); \
  int index=ipop_fast()*xdata[addr-2]+index2; \
  if ((index2<0)||(index2>=xdata[addr-2])||(index<0)||(index>=xdata[addr-1])) \
    { \
      rterror(FN_ARRAY,30); \
      return; \
    }  \
  TOS=addr+index*(sizeof(typ)/sizeof(int));

#endif




