#ifndef CODE_H
#define CODE_H

#include "modeldef.h"

#ifndef DEBUGCOMP
#define ADDCODE(x) { addcode(x); }
#define ADDCODEP(x) { addcodep(x); }
#define ADDVAL(x) { addcodei(x); }
#define ADDVALF(x) { addcodef(x); }
#define ADDVALS(x) { addcodes(x); }
#ifdef LSI_C
#define ADDJMP(jmp,x) { addcodei(jmp | ((((int)(x)/2) & 0x3FFF))); }
#endif
#ifdef __HITACHI__
#define ADDJMP(jmp,x) { addcode(jmp); addcodei((int)x); }
#endif
#else
#define ADDCODE(x) { addcode(x); OutputITrm(x); OutputTrm((uchar*) "\xF1" "/" #x " "); }
#define ADDCODEP(x) { addcodep(x); OutputITrm((int)x.c); }
#define ADDVAL(x) { addcodei(x); OutputITrm(x); }
#define ADDVALF(x) { addcodef(x); OutputFTrm(x); }
#define ADDVALS(x) { addcodes(x); OutputTrm(x); }
#ifdef LSI_C
#define ADDJMP(jmp,x) { addcodei(jmp | ((((int)(x)/2) & 0x3fff))); OutputTrm((uchar*) "JMP "); OutputITrm(jmp); OutputITrm((int)x); }
#endif
#ifdef __HITACHI__
#define ADDJMP(jmp,x) { addcode(jmp); addcodei((int)x); OutputTrm((uchar*) "JMP "); OutputITrm(jmp); OutputITrm((int)x); }
#endif
#endif

#ifdef LSI_C
#define LINKJMP(caddr,laddr) {*(caddr)=(*(caddr) & 0xc000) | (((((int)laddr)/2) & 0x3FFF)); }
#define JMP 0x8000
#define JMPIF 0x4000
#define JMPIFNOT 0xC000
#endif

#ifdef __HITACHI__
#define LINKJMP(caddr,laddr) {*(caddr+1)=(int)laddr; }
#define JMP B_JMP
#define JMPIF B_JMPIF
#define JMPIFNOT B_JMPIFNOT
#endif

typedef unsigned int codet;
typedef unsigned char small_codet;
typedef union _pc
{
  codet *c;
  codet **p;
  char *b;
  int *i;
  FLOATT *f;
  union _pc *pc;
} PC;

void addcode(codet cd);
void addcodep(PC pc);
void addcodei(int val);
void addcodef(FLOATT val);
void addcodes(char *valp);
#endif
