/*
 * modeldef.h
 *
 * common defines model dependent
 */
#ifndef modeldef_h_included
#define modeldef_h_included

#ifdef __HITACHI__

#include <string.h>
#include <hitachi.h>
#include <setjmp.h>
#include "libc.h"

#undef FILE_OPEN_MODE
#define FILE_OPEN_MODE IMB_FILE_OPEN_MODE
#undef FILE_SECRET_MODE
#define FILE_SECRET_MODE IMB_FILE_SECRET_MODE

#define FAR /* nothing */
#define NEAR /* nothing */
#define far_strcpy strcpy
#define far_strncpy strncpy
#define far_strcmp strcmp
#define far_strncmp strncmp
#define far_memcpy memcpy
#define far_strchr strchr
#define far_strrchr strrchr
#define far_memset memset
#define far_strlen strlen
#define far_strcat strcat

/* types of defined size */
typedef int int32;
typedef unsigned int uint32;
typedef short int16;
typedef unsigned short uint16;
#endif

#ifdef LSI_C

#include <stdrom.h>
#include "libc.h"
#include "l_libc.h"

#define FAR far
#define NEAR near

/* types of defined size */
typedef long int int32;
typedef unsigned long int uint32;
typedef int int16;
typedef unsigned int uint16;
#endif

#endif
