/* Sound for OWBasic
   Based on an idea from Alessandro Dorigatti                      *
 * --------------------------------------------------------------- */

#include "modeldef.h"

#ifdef LSI_C

/* WARNING!: here we write directly to the hardware port #0...     *
 * --------  Moreover, to set buzzer "on/off" we write a byte with *
 *           bit 7 on/off: normally only bits 0..2 are used in     *
 *           PVOS. Then USE THIS FUNCTION ON YOUR OWN RISK!        */

/* Thank you, Johannes (Steingraeber) ---------------------------- */

#define outpsound(c) _asm_sound("\n OUT 00h,AL\n",c)
void _asm_sound(char *, char);
#endif

/* --------------------------------------------------------------- */

int sound (int ptch, unsigned int dur, unsigned int wav);
int play (uchar*nn,  unsigned int dur, unsigned int wav);



