/*
 * ModeCall - Library for Pocketviewer
 *
 * Copyright (C) 2002 Wolfgang Ortmann
 * Contact: noo@uni-jena.de
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <modecall.h>
/*
  general functions - status.c
  functions for calling program - status1.c
  functions for called program - status2.c
*/

word mc_CallerMode()
{
  return *MCP_MODEWORD;
}

/*
 * is current mode called via ModeCall 
 */
bool mc_isCall()
{
  if ((getstate() & MC_CALLMASK)!=MC_CALLVALUE) return FALSE;
  return (*MCP_VERSION==MC_VERSION);
}

